# This file is a template, and might need editing before it works on your project.
# Official framework image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/node/tags/
image: node:14.14.0-stretch

stages:
  - build frontend
  - test
  - sonar scan
  - deploy dev
  - release uat
  

# cache:
#   paths:
#     - node_modules/

build frontend:
  stage: build frontend
  # only:
  #   - master
  before_script:
      - cd frontend
      - npm i 
  script:
    - ls -ltr
    - pwd
    - npm run build

  artifacts:
   paths:
    - frontend/dist/

unit test:
  stage: test 
  script: 
    - npm i
    - npm test src/tests/

deploy dev:
  stage: deploy dev
  only:
    - master
  before_script:
    - npm config set prefix /usr/local
    - npm i
    - npm i -g serverless
    - VERSION=`cat version.txt`
    - echo "Version to deploy is $VERSION"

  script:
    - serverless deploy --stage dev --verbose
  environment: dev

release uat:
  stage: release uat 
  only:
    - master
  when: manual 
  before_script:
     - VERSION=`cat version.txt`
     - echo "Version to tag will be" `${VERSION%-*}`

  script:
    - echo "deploy uat ... Waiting for manual approval."
    - echo "similar stuff will be used in deploy uat stage"

sonar scan:
  stage: sonar scan
  script:
    - echo "Scanning stage"
  environment: dev

# SonarCloud Configuration
# To turn on/off sonarCloud Check, comment out script below.
variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  stage: sonar scan
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
  only:
    # - merge_requests
    # - develop
    - master

